Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -1755,81 +1897,74 @@
 !--          b) Aerosol mass concentrations
 !--             bin subrange 1: done here separately due to the SO4/OC convention
+!
 !--          SO4:
-             IF ( iso4 > 0 )  THEN
-                ss = ( iso4 - 1 ) * nbins + in1a !< start
-                ee = ( iso4 - 1 ) * nbins + fn1a !< end
-                b = in1a
-                DO  c = ss, ee
-                   aerosol_mass(c)%conc(k,j,i) = MAX( 0.0_wp, 1.0_wp -         &
-                                                  pvfOC1a(k) ) * pndist(k,b) * &
-                                                  core(b) * arhoh2so4 * flag
+             IF ( index_so4 > 0 )  THEN
+                ss = ( index_so4 - 1 ) * nbins_aerosol + start_subrange_1a !< start
+                ee = ( index_so4 - 1 ) * nbins_aerosol + end_subrange_1a !< end
+                ib = start_subrange_1a
+                DO  ic = ss, ee
+                   aerosol_mass(ic)%conc(k,j,i) = MAX( 0.0_wp, 1.0_wp - pmfoc1a(k) ) * pndist(k,ib)&
+                                                  * core(ib) * arhoh2so4 * flag
                    IF ( prunmode == 1 )  THEN
-                      aerosol_mass(c)%init = MAX( 0.0_wp, 1.0_wp - MAXVAL(     &
-                                             pvfOC1a ) ) * pndist(:,b) *       &
-                                             core(b) * arhoh2so4
+                      aerosol_mass(ic)%init(k) = MAX( 0.0_wp, 1.0_wp - pmfoc1a(k) ) * pndist(k,ib) &
+                                                 * core(ib) * arhoh2so4
                    ENDIF
-                   b = b+1
+                   ib = ib+1
                 ENDDO
              ENDIF
+!
 !--          OC:
-             IF ( ioc > 0 ) THEN
-                ss = ( ioc - 1 ) * nbins + in1a !< start
-                ee = ( ioc - 1 ) * nbins + fn1a !< end 
-                b = in1a
-                DO  c = ss, ee 
-                   aerosol_mass(c)%conc(k,j,i) = MAX( 0.0_wp, pvfOC1a(k) ) *   &
-                                           pndist(k,b) * core(b) * arhooc * flag
+             IF ( index_oc > 0 ) THEN
+                ss = ( index_oc - 1 ) * nbins_aerosol + start_subrange_1a !< start
+                ee = ( index_oc - 1 ) * nbins_aerosol + end_subrange_1a !< end
+                ib = start_subrange_1a
+                DO  ic = ss, ee 
+                   aerosol_mass(ic)%conc(k,j,i) = MAX( 0.0_wp, pmfoc1a(k) ) * pndist(k,ib) *       &
+                                                  core(ib) * arhooc * flag
                    IF ( prunmode == 1 )  THEN
-                      aerosol_mass(c)%init = MAX( 0.0_wp, MAXVAL( pvfOC1a ) )  &
-                                             * pndist(:,b) *  core(b) * arhooc
+                      aerosol_mass(ic)%init(k) = MAX( 0.0_wp, pmfoc1a(k) ) * pndist(k,ib) *        &
+                                                 core(ib) * arhooc
                    ENDIF
-                   b = b+1
+                   ib = ib+1
                 ENDDO 
              ENDIF
-             
-             prunmode = 3  ! Init only once
-  
           ENDDO !< k
+
+          prunmode = 3  ! Init only once
+
        ENDDO !< j
     ENDDO !< i
-    
+
 !
 !-- c) Aerosol mass concentrations
 !--    bin subrange 2:
     IF ( nreg > 1 ) THEN
-    
-       IF ( iso4 > 0 ) THEN
-          CALL set_aero_mass( iso4, pvf2a(:,1), pvf2b(:,1), pnf2a, pndist,     &
-                              core, arhoh2so4 )
-       ENDIF
-       IF ( ioc > 0 ) THEN
-          CALL set_aero_mass( ioc, pvf2a(:,2), pvf2b(:,2), pnf2a, pndist, core,&
-                              arhooc )
-       ENDIF
-       IF ( ibc > 0 ) THEN
-          CALL set_aero_mass( ibc, pvf2a(:,3), pvf2b(:,3), pnf2a, pndist, core,&
-                              arhobc )
-       ENDIF
-       IF ( idu > 0 ) THEN
-          CALL set_aero_mass( idu, pvf2a(:,4), pvf2b(:,4), pnf2a, pndist, core,&
-                              arhodu )
-       ENDIF
-       IF ( iss > 0 ) THEN
-          CALL set_aero_mass( iss, pvf2a(:,5), pvf2b(:,5), pnf2a, pndist, core,&
-                              arhoss )
-       ENDIF
-       IF ( ino > 0 ) THEN
-          CALL set_aero_mass( ino, pvf2a(:,6), pvf2b(:,6), pnf2a, pndist, core,&
-                              arhohno3 )
-       ENDIF
-       IF ( inh > 0 ) THEN
-          CALL set_aero_mass( inh, pvf2a(:,7), pvf2b(:,7), pnf2a, pndist, core,&
-                              arhonh3 )
+
+       IF ( index_so4 > 0 ) THEN
+          CALL set_aero_mass( index_so4, pmf2a(:,1), pmf2b(:,1), pnf2a, pndist, core, arhoh2so4 )
+       ENDIF
+       IF ( index_oc > 0 ) THEN
+          CALL set_aero_mass( index_oc, pmf2a(:,2), pmf2b(:,2), pnf2a, pndist, core, arhooc )
+       ENDIF
+       IF ( index_bc > 0 ) THEN
+          CALL set_aero_mass( index_bc, pmf2a(:,3), pmf2b(:,3), pnf2a, pndist, core, arhobc )
+       ENDIF
+       IF ( index_du > 0 ) THEN
+          CALL set_aero_mass( index_du, pmf2a(:,4), pmf2b(:,4), pnf2a, pndist, core, arhodu )
+       ENDIF
+       IF ( index_ss > 0 ) THEN
+          CALL set_aero_mass( index_ss, pmf2a(:,5), pmf2b(:,5), pnf2a, pndist, core, arhoss )
+       ENDIF
+       IF ( index_no > 0 ) THEN
+          CALL set_aero_mass( index_no, pmf2a(:,6), pmf2b(:,6), pnf2a, pndist, core, arhohno3 )
+       ENDIF
+       IF ( index_nh > 0 ) THEN
+          CALL set_aero_mass( index_nh, pmf2a(:,7), pmf2b(:,7), pnf2a, pndist, core, arhonh3 )
        ENDIF
 
     ENDIF
-    
+
  END SUBROUTINE aerosol_init
- 
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -1839,51 +1974,52 @@
 !------------------------------------------------------------------------------!
  SUBROUTINE size_distribution( in_ntot, in_dpg, in_sigma, psd_sect )
-   
+
     IMPLICIT NONE
-   
-!-- Log-normal size distribution: modes   
-    REAL(wp), DIMENSION(:), INTENT(in) ::  in_dpg    !< geometric mean diameter 
-                                                     !< (micrometres) 
-    REAL(wp), DIMENSION(:), INTENT(in) ::  in_ntot   !< number conc. (#/cm3)
+
+    INTEGER(iwp) ::  ib         !< running index: bin
+    INTEGER(iwp) ::  iteration  !< running index: iteration
+
+    REAL(wp) ::  d1         !< particle diameter (m, dummy)
+    REAL(wp) ::  d2         !< particle diameter (m, dummy)
+    REAL(wp) ::  delta_d    !< (d2-d1)/10
+    REAL(wp) ::  deltadp    !< bin width
+    REAL(wp) ::  dmidi      !< ( d1 + d2 ) / 2
+
+    REAL(wp), DIMENSION(:), INTENT(in) ::  in_dpg    !< geometric mean diameter (m)
+    REAL(wp), DIMENSION(:), INTENT(in) ::  in_ntot   !< number conc. (#/m3)
     REAL(wp), DIMENSION(:), INTENT(in) ::  in_sigma  !< standard deviation
-    REAL(wp), DIMENSION(:), INTENT(inout) ::  psd_sect !< sectional size 
-                                                       !< distribution
-    INTEGER(iwp) ::  b          !< running index: bin
-    INTEGER(iwp) ::  ib         !< running index: iteration
-    REAL(wp) ::  d1             !< particle diameter (m, dummy)
-    REAL(wp) ::  d2             !< particle diameter (m, dummy)
-    REAL(wp) ::  delta_d        !< (d2-d1)/10                                                      
-    REAL(wp) ::  deltadp        !< bin width 
-    REAL(wp) ::  dmidi          !< ( d1 + d2 ) / 2
-    
-    DO  b = in1a, fn2b !< aerosol size bins
-       psd_sect(b) = 0.0_wp
+
+    REAL(wp), DIMENSION(:), INTENT(inout) ::  psd_sect  !< sectional size distribution
+
+    DO  ib = start_subrange_1a, end_subrange_2b
+       psd_sect(ib) = 0.0_wp
+!
 !--    Particle diameter at the low limit (largest in the bin) (m)
-       d1 = ( aero(b)%vlolim / api6 ) ** ( 1.0_wp / 3.0_wp )
+       d1 = ( aero(ib)%vlolim / api6 )**0.33333333_wp
+!
 !--    Particle diameter at the high limit (smallest in the bin) (m)
-       d2 = ( aero(b)%vhilim / api6 ) ** ( 1.0_wp / 3.0_wp )
+       d2 = ( aero(ib)%vhilim / api6 )**0.33333333_wp
+!
 !--    Span of particle diameter in a bin (m)
-       delta_d = ( d2 - d1 ) / 10.0_wp
-!--    Iterate:             
-       DO  ib = 1, 10
-          d1 = ( aero(b)%vlolim / api6 ) ** ( 1.0_wp / 3.0_wp ) + ( ib - 1)    &
-               * delta_d
+       delta_d = 0.1_wp * ( d2 - d1 )
+!
+!--    Iterate:
+       DO  iteration = 1, 10
+          d1 = ( aero(ib)%vlolim / api6 )**0.33333333_wp + ( ib - 1) * delta_d
           d2 = d1 + delta_d
-          dmidi = ( d1 + d2 ) / 2.0_wp
+          dmidi = 0.5_wp * ( d1 + d2 )
           deltadp = LOG10( d2 / d1 )
-          
+!
 !--       Size distribution
 !--       in_ntot = total number, total area, or total volume concentration
 !--       in_dpg = geometric-mean number, area, or volume diameter
 !--       n(k) = number, area, or volume concentration in a bin
-!--       n_lognorm and dpg converted to units of #/m3 and m
-          psd_sect(b) = psd_sect(b) + SUM( in_ntot * 1.0E+6_wp * deltadp /     &
-                     ( SQRT( 2.0_wp * pi ) * LOG10( in_sigma ) ) *             &
-                     EXP( -LOG10( dmidi / ( 1.0E-6_wp * in_dpg ) )**2.0_wp /   &
-                     ( 2.0_wp * LOG10( in_sigma ) ** 2.0_wp ) ) )
- 
+          psd_sect(ib) = psd_sect(ib) + SUM( in_ntot * deltadp / ( SQRT( 2.0_wp * pi ) *           &
+                        LOG10( in_sigma ) ) * EXP( -LOG10( dmidi / in_dpg )**2.0_wp /              &
+                        ( 2.0_wp * LOG10( in_sigma ) ** 2.0_wp ) ) )
+
        ENDDO
     ENDDO
-   
+
  END SUBROUTINE size_distribution
 
@@ -1895,70 +2031,219 @@
 !> Tomi Raatikainen, FMI, 29.2.2016
 !------------------------------------------------------------------------------!
- SUBROUTINE set_aero_mass( ispec, ppvf2a, ppvf2b, ppnf2a, ppndist, pcore, prho )
-    
+ SUBROUTINE set_aero_mass( ispec, pmf2a, pmf2b, pnf2a, pndist, pcore, prho )
+
     IMPLICIT NONE
 
+    INTEGER(iwp) ::  ee        !< index: end
+    INTEGER(iwp) ::  i         !< loop index
+    INTEGER(iwp) ::  ib        !< loop index
+    INTEGER(iwp) ::  ic        !< loop index
+    INTEGER(iwp) ::  j         !< loop index
+    INTEGER(iwp) ::  k         !< loop index
+    INTEGER(iwp) ::  prunmode  !< 1 = initialise
+    INTEGER(iwp) ::  ss        !< index: start
+
     INTEGER(iwp), INTENT(in) :: ispec  !< Aerosol species index
-    REAL(wp), INTENT(in) ::  pcore(nbins) !< Aerosol bin mid core volume    
-    REAL(wp), INTENT(in) ::  ppndist(0:nz+1,nbins) !< Aerosol size distribution
-    REAL(wp), INTENT(in) ::  ppnf2a(0:nz+1) !< Number fraction for 2a    
-    REAL(wp), INTENT(in) ::  ppvf2a(0:nz+1) !< Mass distributions for a 
-    REAL(wp), INTENT(in) ::  ppvf2b(0:nz+1) !< and b bins    
+
+    REAL(wp) ::  flag   !< flag to mask topography grid points
+
     REAL(wp), INTENT(in) ::  prho !< Aerosol density
-    INTEGER(iwp) ::  b  !< loop index 
-    INTEGER(iwp) ::  c  !< loop index        
-    INTEGER(iwp) ::  ee !< index: end 
-    INTEGER(iwp) ::  i  !< loop index 
-    INTEGER(iwp) ::  j  !< loop index 
-    INTEGER(iwp) ::  k  !< loop index
-    INTEGER(iwp) ::  prunmode  !< 1 = initialise
-    INTEGER(iwp) ::  ss !< index: start 
-    REAL(wp) ::  flag   !< flag to mask topography grid points
-    
+
+    REAL(wp), DIMENSION(nbins_aerosol), INTENT(in) ::  pcore !< Aerosol bin mid core volume
+    REAL(wp), DIMENSION(0:nz+1), INTENT(in)        ::  pnf2a !< Number fraction for 2a
+    REAL(wp), DIMENSION(0:nz+1), INTENT(in)        ::  pmf2a !< Mass distributions for a
+    REAL(wp), DIMENSION(0:nz+1), INTENT(in)        ::  pmf2b !< and b bins
+
+    REAL(wp), DIMENSION(0:nz+1,nbins_aerosol), INTENT(in) ::  pndist !< Aerosol size distribution
+
     prunmode = 1
-    
-    DO i = nxlg, nxrg 
+
+    DO i = nxlg, nxrg
        DO j = nysg, nyng
-          DO k = nzb, nzt+1  
+          DO k = nzb, nzt+1
 !
 !--          Predetermine flag to mask topography
              flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) ) 
-!             
+!
 !--          Regime 2a:
-             ss = ( ispec - 1 ) * nbins + in2a
-             ee = ( ispec - 1 ) * nbins + fn2a
-             b = in2a
-             DO c = ss, ee
-                aerosol_mass(c)%conc(k,j,i) = MAX( 0.0_wp, ppvf2a(k) ) *       &
-                               ppnf2a(k) * ppndist(k,b) * pcore(b) * prho * flag
+             ss = ( ispec - 1 ) * nbins_aerosol + start_subrange_2a
+             ee = ( ispec - 1 ) * nbins_aerosol + end_subrange_2a
+             ib = start_subrange_2a
+             DO ic = ss, ee
+                aerosol_mass(ic)%conc(k,j,i) = MAX( 0.0_wp, pmf2a(k) ) * pnf2a(k) * pndist(k,ib) * &
+                                              pcore(ib) * prho * flag
                 IF ( prunmode == 1 )  THEN
-                   aerosol_mass(c)%init = MAX( 0.0_wp, MAXVAL( ppvf2a(:) ) ) * &
-                                          MAXVAL( ppnf2a ) * pcore(b) * prho * &
-                                          MAXVAL( ppndist(:,b) ) 
+                   aerosol_mass(ic)%init(k) = MAX( 0.0_wp, pmf2a(k) ) * pnf2a(k) * pndist(k,ib) *  &
+                                              pcore(ib) * prho
                 ENDIF
-                b = b+1
+                ib = ib + 1
              ENDDO
+!
 !--          Regime 2b:
              IF ( .NOT. no_insoluble )  THEN
-                ss = ( ispec - 1 ) * nbins + in2b
-                ee = ( ispec - 1 ) * nbins + fn2b
-                b = in2a
-                DO c = ss, ee
-                   aerosol_mass(c)%conc(k,j,i) = MAX( 0.0_wp, ppvf2b(k) ) * (  &
-                                         1.0_wp - ppnf2a(k) ) * ppndist(k,b) * &
-                                         pcore(b) * prho * flag
+                ss = ( ispec - 1 ) * nbins_aerosol + start_subrange_2b
+                ee = ( ispec - 1 ) * nbins_aerosol + end_subrange_2b
+                ib = start_subrange_2a
+                DO ic = ss, ee
+                   aerosol_mass(ic)%conc(k,j,i) = MAX( 0.0_wp, pmf2b(k) ) * ( 1.0_wp - pnf2a(k) ) *&
+                                                  pndist(k,ib) * pcore(ib) * prho * flag
                    IF ( prunmode == 1 )  THEN
-                      aerosol_mass(c)%init = MAX( 0.0_wp, MAXVAL( ppvf2b(:) ) )&
-                                        * ( 1.0_wp - MAXVAL( ppnf2a ) ) *      &
-                                        MAXVAL( ppndist(:,b) ) * pcore(b) * prho
+                      aerosol_mass(ic)%init(k) = MAX( 0.0_wp, pmf2b(k) ) * ( 1.0_wp - pnf2a(k) ) * &
+                                                 pndist(k,ib) * pcore(ib) * prho 
                    ENDIF
-                   b = b+1
-                ENDDO
+                   ib = ib + 1
+                ENDDO  ! c
+
              ENDIF
-             prunmode = 3  ! Init only once
-          ENDDO
+          ENDDO   ! k
+
+          prunmode = 3  ! Init only once
+
+       ENDDO   ! j
+    ENDDO   ! i
+
+ END SUBROUTINE set_aero_mass
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Initialise the matching between surface types in LSM and deposition models.
+!> Do the matching based on Zhang et al. (2001). Atmos. Environ. 35, 549-560
+!> (here referred as Z01).
+!------------------------------------------------------------------------------!
+ SUBROUTINE init_deposition
+
+    USE surface_mod,                                                                               &
+        ONLY:  surf_lsm_h, surf_lsm_v
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  l  !< loop index for vertical surfaces
+
+    IF ( nldepo_surf  .AND.  land_surface )  THEN
+
+       ALLOCATE( lsm_to_depo_h%match(1:surf_lsm_h%ns) )
+       lsm_to_depo_h%match = 0
+       CALL match_lsm_zhang( surf_lsm_h, lsm_to_depo_h%match )
+
+       DO  l = 0, 3
+          ALLOCATE( lsm_to_depo_v(l)%match(1:surf_lsm_v(l)%ns) )
+          lsm_to_depo_v(l)%match = 0
+          CALL match_lsm_zhang( surf_lsm_v(l), lsm_to_depo_v(l)%match )
        ENDDO
+    ENDIF
+
+    IF ( nldepo_pcm )  THEN
+       SELECT CASE ( depo_pcm_type )
+          CASE ( 'evergreen_needleleaf' )
+             depo_pcm_type_num = 1
+          CASE ( 'evergreen_broadleaf' )
+             depo_pcm_type_num = 2
+          CASE ( 'deciduous_needleleaf' )
+             depo_pcm_type_num = 3
+          CASE ( 'deciduous_broadleaf' )
+             depo_pcm_type_num = 4
+          CASE DEFAULT
+             message_string = 'depo_pcm_type not set correctly.'
+             CALL message( 'salsa_mod: init_deposition', 'PA0613', 1, 2, 0, 6, 0 )
+       END SELECT
+    ENDIF
+
+ END SUBROUTINE init_deposition
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Match the surface types in PALM and Zhang et al. 2001 deposition module
+!------------------------------------------------------------------------------!
+ SUBROUTINE match_lsm_zhang( surf, match_array )
+
+    USE surface_mod,                                                           &
+        ONLY:  ind_pav_green, ind_veg_wall, ind_wat_win, surf_type
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  m                !< index for surface elements
+    INTEGER(iwp) ::  pav_type_palm    !< pavement type in PALM
+    INTEGER(iwp) ::  vege_type_palm   !< vegetation type in PALM
+    INTEGER(iwp) ::  water_type_palm  !< water type in PALM
+
+    INTEGER(iwp), DIMENSION(:), INTENT(inout) ::  match_array !< array matching
+                                                              !< the surface types
+    TYPE(surf_type), INTENT(in) :: surf  !< respective surface type
+
+    DO  m = 1, surf%ns
+
+       IF ( surf%frac(ind_veg_wall,m) > 0 )  THEN
+          vege_type_palm = surf%vegetation_type(m)
+          SELECT CASE ( vege_type_palm )
+             CASE ( 0 )
+                message_string = 'No vegetation type defined.'
+                CALL message( 'salsa_mod: init_depo_surfaces', 'PA0614', 1, 2, 0, 6, 0 )
+             CASE ( 1 )  ! bare soil
+                match_array(m) = 6  ! grass in Z01
+             CASE ( 2 )  ! crops, mixed farming
+                match_array(m) = 7  !  crops, mixed farming Z01
+             CASE ( 3 )  ! short grass
+                match_array(m) = 6  ! grass in Z01
+             CASE ( 4 )  ! evergreen needleleaf trees
+                 match_array(m) = 1  ! evergreen needleleaf trees in Z01
+             CASE ( 5 )  ! deciduous needleleaf trees
+                match_array(m) = 3  ! deciduous needleleaf trees in Z01
+             CASE ( 6 )  ! evergreen broadleaf trees
+                match_array(m) = 2  ! evergreen broadleaf trees in Z01
+             CASE ( 7 )  ! deciduous broadleaf trees
+                match_array(m) = 4  ! deciduous broadleaf trees in Z01
+             CASE ( 8 )  ! tall grass
+                match_array(m) = 6  ! grass in Z01
+             CASE ( 9 )  ! desert
+                match_array(m) = 8  ! desert in Z01
+             CASE ( 10 )  ! tundra
+                match_array(m) = 9  ! tundra in Z01
+             CASE ( 11 )  ! irrigated crops
+                match_array(m) = 7  !  crops, mixed farming Z01
+             CASE ( 12 )  ! semidesert
+                match_array(m) = 8  ! desert in Z01
+             CASE ( 13 )  ! ice caps and glaciers
+                match_array(m) = 12  ! ice cap and glacier in Z01
+             CASE ( 14 )  ! bogs and marshes
+                match_array(m) = 11  ! wetland with plants in Z01
+             CASE ( 15 )  ! evergreen shrubs
+                match_array(m) = 10  ! shrubs and interrupted woodlands in Z01
+             CASE ( 16 )  ! deciduous shrubs
+                match_array(m) = 10  ! shrubs and interrupted woodlands in Z01
+             CASE ( 17 )  ! mixed forest/woodland
+                match_array(m) = 5  ! mixed broadleaf and needleleaf trees in Z01
+             CASE ( 18 )  ! interrupted forest
+                match_array(m) = 10  ! shrubs and interrupted woodlands in Z01
+          END SELECT
+       ENDIF
+
+       IF ( surf%frac(ind_pav_green,m) > 0 )  THEN
+          pav_type_palm = surf%pavement_type(m)
+          IF ( pav_type_palm == 0 )  THEN  ! error
+             message_string = 'No pavement type defined.'
+             CALL message( 'salsa_mod: match_lsm_zhang', 'PA0615', 1, 2, 0, 6, 0 )
+          ELSEIF ( pav_type_palm > 0  .AND.  pav_type_palm <= 15 )  THEN
+             match_array(m) = 15  ! urban in Z01
+          ENDIF
+       ENDIF
+
+       IF ( surf%frac(ind_wat_win,m) > 0 )  THEN
+          water_type_palm = surf%water_type(m)
+          IF ( water_type_palm == 0 )  THEN  ! error
+             message_string = 'No water type defined.'
+             CALL message( 'salsa_mod: match_lsm_zhang', 'PA0616', 1, 2, 0, 6, 0 )
+          ELSEIF ( water_type_palm == 3 )  THEN
+             match_array(m) = 14  ! ocean in Z01
+          ELSEIF ( water_type_palm == 1  .OR.  water_type_palm == 2 .OR.  water_type_palm == 4     &
+                   .OR.  water_type_palm == 5  )  THEN
+             match_array(m) = 13  ! inland water in Z01
+          ENDIF
+       ENDIF
+
     ENDDO
- END SUBROUTINE set_aero_mass
+
+ END SUBROUTINE match_lsm_zhang
 
 !------------------------------------------------------------------------------!
@@ -1971,65 +2256,55 @@
     IMPLICIT NONE
 
+    INTEGER(iwp) ::  ib   !<
+    INTEGER(iwp) ::  ic   !<
+    INTEGER(iwp) ::  icc  !<
+    INTEGER(iwp) ::  ig   !<
+
     INTEGER(iwp), INTENT(IN) ::  mod_count  !<
-    INTEGER(iwp) ::  b  !<    
-    INTEGER(iwp) ::  c  !<    
-    INTEGER(iwp) ::  cc !<
-    INTEGER(iwp) ::  g  !<
-
-    IF ( simulated_time >= time_since_reference_point )  THEN
-
-    SELECT CASE ( mod_count )
-
-       CASE ( 0 )
-
-          DO  b = 1, nbins
-             aerosol_number(b)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)   =>        &
-                nconc_1(:,:,:,b)
-             aerosol_number(b)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg) =>        &
-                nconc_2(:,:,:,b)
-             DO  c = 1, ncc_tot
-                cc = ( c-1 ) * nbins + b  ! required due to possible Intel18 bug
-                aerosol_mass(cc)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)   =>      &
-                   mconc_1(:,:,:,cc)
-                aerosol_mass(cc)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg) =>      &
-                   mconc_2(:,:,:,cc)
+
+    IF ( time_since_reference_point >= skip_time_do_salsa )  THEN
+
+       SELECT CASE ( mod_count )
+
+          CASE ( 0 )
+
+             DO  ib = 1, nbins_aerosol
+                aerosol_number(ib)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)   => nconc_1(:,:,:,ib)
+                aerosol_number(ib)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg) => nconc_2(:,:,:,ib)
+
+                DO  ic = 1, ncomponents_mass
+                   icc = ( ic-1 ) * nbins_aerosol + ib
+                   aerosol_mass(icc)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)   => mconc_1(:,:,:,icc)
+                   aerosol_mass(icc)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg) => mconc_2(:,:,:,icc)
+                ENDDO
              ENDDO
-          ENDDO
-          
-          IF ( .NOT. salsa_gases_from_chem )  THEN
-             DO  g = 1, ngast
-                salsa_gas(g)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)   =>          &
-                   gconc_1(:,:,:,g)
-                salsa_gas(g)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg) =>          &
-                   gconc_2(:,:,:,g)
+
+             IF ( .NOT. salsa_gases_from_chem )  THEN
+                DO  ig = 1, ngases_salsa
+                   salsa_gas(ig)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)   => gconc_1(:,:,:,ig)
+                   salsa_gas(ig)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg) => gconc_2(:,:,:,ig)
+                ENDDO
+             ENDIF
+
+          CASE ( 1 )
+
+             DO  ib = 1, nbins_aerosol
+                aerosol_number(ib)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)   => nconc_2(:,:,:,ib)
+                aerosol_number(ib)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg) => nconc_1(:,:,:,ib)
+                DO  ic = 1, ncomponents_mass
+                   icc = ( ic-1 ) * nbins_aerosol + ib
+                   aerosol_mass(icc)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)   => mconc_2(:,:,:,icc)
+                   aerosol_mass(icc)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg) => mconc_1(:,:,:,icc)
+                ENDDO
              ENDDO
-          ENDIF
-
-       CASE ( 1 )
-
-          DO  b = 1, nbins
-             aerosol_number(b)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)   =>        &
-                nconc_2(:,:,:,b)
-             aerosol_number(b)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg) =>        &
-                nconc_1(:,:,:,b)
-             DO  c = 1, ncc_tot
-                cc = ( c-1 ) * nbins + b  ! required due to possible Intel18 bug
-                aerosol_mass(cc)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)   =>      &
-                   mconc_2(:,:,:,cc)
-                aerosol_mass(cc)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg) =>      &
-                   mconc_1(:,:,:,cc)
-             ENDDO
-          ENDDO
-          
-          IF ( .NOT. salsa_gases_from_chem )  THEN
-             DO  g = 1, ngast
-                salsa_gas(g)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)   =>          &
-                   gconc_2(:,:,:,g)
-                salsa_gas(g)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg) =>          &
-                   gconc_1(:,:,:,g)
-             ENDDO
-          ENDIF
-
-    END SELECT
+
+             IF ( .NOT. salsa_gases_from_chem )  THEN
+                DO  ig = 1, ngases_salsa
+                   salsa_gas(ig)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)   => gconc_2(:,:,:,ig)
+                   salsa_gas(ig)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg) => gconc_1(:,:,:,ig)
+                ENDDO
+             ENDIF
+
+       END SELECT
 
     ENDIF
@@ -2043,15 +2318,13 @@
 !> This routine reads the respective restart data.
 !------------------------------------------------------------------------------!
- SUBROUTINE salsa_rrd_local( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,           &
-                             nxr_on_file, nynf, nync, nyn_on_file, nysf,       &
-                             nysc, nys_on_file, tmp_3d, found )
-
-    
+ SUBROUTINE salsa_rrd_local( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc, nxr_on_file, nynf, nync,      &
+                             nyn_on_file, nysf, nysc, nys_on_file, tmp_3d, found )
+
     IMPLICIT NONE
-    
-    INTEGER(iwp) ::  b  !<    
-    INTEGER(iwp) ::  c  !<
-    INTEGER(iwp) ::  g  !<
-    INTEGER(iwp) ::  k  !<
+
+    INTEGER(iwp) ::  ib              !<
+    INTEGER(iwp) ::  ic              !<
+    INTEGER(iwp) ::  ig              !<
+    INTEGER(iwp) ::  k               !<
     INTEGER(iwp) ::  nxlc            !<
     INTEGER(iwp) ::  nxlf            !<
@@ -2067,47 +2340,46 @@
     INTEGER(iwp) ::  nys_on_file     !<
 
-    LOGICAL, INTENT(OUT)  ::  found
+    LOGICAL, INTENT(OUT)  ::  found  !<
 
     REAL(wp), &
        DIMENSION(nzb:nzt+1,nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) :: tmp_3d   !<
-       
+
     found = .FALSE.
-    
+
     IF ( read_restart_data_salsa )  THEN
-    
+
        SELECT CASE ( restart_string(1:length) )
-       
+
           CASE ( 'aerosol_number' )
-             DO  b = 1, nbins
+             DO  ib = 1, nbins_aerosol
                 IF ( k == 1 )  READ ( 13 ) tmp_3d
-                aerosol_number(b)%conc(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = & 
-                               tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                aerosol_number(ib)%conc(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =               &
+                                                   tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
                 found = .TRUE.
              ENDDO
-       
+
           CASE ( 'aerosol_mass' )
-             DO  c = 1, ncc_tot * nbins
+             DO  ic = 1, ncomponents_mass * nbins_aerosol
                 IF ( k == 1 )  READ ( 13 ) tmp_3d
-                aerosol_mass(c)%conc(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = & 
-                               tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                aerosol_mass(ic)%conc(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =                 &
+                                                   tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
                 found = .TRUE.
              ENDDO
-          
+
           CASE ( 'salsa_gas' )
-             DO  g = 1, ngast
+             DO  ig = 1, ngases_salsa
                 IF ( k == 1 )  READ ( 13 ) tmp_3d
-                salsa_gas(g)%conc(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =  & 
-                               tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                salsa_gas(ig)%conc(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =                    &
+                                                   tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
                 found = .TRUE.
              ENDDO
-             
+
           CASE DEFAULT
              found = .FALSE.
-             
+
        END SELECT
     ENDIF
 
  END SUBROUTINE salsa_rrd_local
-    
 
 !------------------------------------------------------------------------------!
@@ -2122,30 +2394,29 @@
 
     IMPLICIT NONE
-    
-    INTEGER(iwp) ::  b  !<    
-    INTEGER(iwp) ::  c  !<
-    INTEGER(iwp) ::  g  !<
-    
+
+    INTEGER(iwp) ::  ib   !<
+    INTEGER(iwp) ::  ic   !<
+    INTEGER(iwp) ::  ig  !<
+
     IF ( write_binary  .AND.  write_binary_salsa )  THEN
-    
+
        CALL wrd_write_string( 'aerosol_number' )
-       DO  b = 1, nbins
-          WRITE ( 14 )  aerosol_number(b)%conc
+       DO  ib = 1, nbins_aerosol
+          WRITE ( 14 )  aerosol_number(ib)%conc
        ENDDO
-       
+
        CALL wrd_write_string( 'aerosol_mass' )
-       DO  c = 1, nbins*ncc_tot
-          WRITE ( 14 )  aerosol_mass(c)%conc
+       DO  ic = 1, nbins_aerosol * ncomponents_mass
+          WRITE ( 14 )  aerosol_mass(ic)%conc
        ENDDO
-       
+
        CALL wrd_write_string( 'salsa_gas' )
-       DO  g = 1, ngast
-          WRITE ( 14 )  salsa_gas(g)%conc
+       DO  ig = 1, ngases_salsa
+          WRITE ( 14 )  salsa_gas(ig)%conc
        ENDDO
-          
+
     ENDIF
-       
- END SUBROUTINE salsa_wrd_local   
-
+
+ END SUBROUTINE salsa_wrd_local
 
 !------------------------------------------------------------------------------!
